﻿// Chapter 11 

// Reflection "reflecting off of the Class"
// structural "at runtime" NOT { encapsulation }
// "replace" some of the static methods with dynamic programming using reflection


using Chapter11;
using System.Reflection;

class Program
{

    static void Main(string[] args)
    {
        Console.WriteLine("=== Chapter 11 Runtime ===");
        Console.WriteLine();

        // Data
        Product product1 = new Product("1234", "Mens_Shoes", 12.50);
        // Type Class to identify instances type
        // Type type1 = typeof(Product); // AFTER
        Type type1 = product1.GetType(); // at runtime

        // Reflection
        Console.WriteLine("Reflection");

        // Accessing the Property Attributes
        PropertyInfo partNumProperty = type1.GetProperty("PartNum");
        PropertyInfo categoryProperty = type1.GetProperty("Category");
        PropertyInfo priceProperty = type1.GetProperty("Price");

        // Get values of properties (partNumProperty)
        string partNumValue = (string)partNumProperty.GetValue(product1);
        string categoryValue = (string)categoryProperty.GetValue(product1);
        double priceValue = (double)priceProperty.GetValue(product1);

        Console.WriteLine("Current Product 1 Price: " + priceValue); // 12.50

        // string SKU =<assigned value> "1234"
        // Modifying property value using reflection
        priceProperty.SetValue(product1, 15.75);

        Console.WriteLine("Current Product 1 Price: " + product1.Price); // 15.75

        // Assembly (Project) Add > Reference
        Assembly assembly = Assembly.LoadFrom("Category.dll");

        // Get the Type of Category Assembly
        Type categoryType = assembly.GetType("Category.Category");
        

        // Create an instance from the Assembly
        // dynamically thru the assembly
        object categoryInstance = Activator.CreateInstance(categoryType,1,"Mens_Shoes");

        // static
        // Class varName = new Class(1, "Mens_Shoes");

        // Access Properties
        PropertyInfo categoryIDProperty = categoryType.GetProperty("CategoryID");
        PropertyInfo categoryNameProperty = categoryType.GetProperty("CategoryName");

        // Display Values
        Console.WriteLine($"Cat ID: {categoryIDProperty.GetValue(categoryInstance)}");
        Console.WriteLine($"Cat Name: {categoryNameProperty.GetValue(categoryInstance)}");

    } //


} // Program



