﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

// Unit Testing
/*
 * NUnit fixtues > data driven
 * xUnit > .net application
 * MS Test > Visual Studio IDE (ui/ux, integration, unit testing)
 * Fluent
 * Mocking Library > Moq
 * SpecFlow > BDD or workflow
 * 
 */

using NUnit.Framework;
using NUnit.Framework.Legacy;
using NUnitLite;

namespace Chapter17
{

    [TestFixture]
    public class CartTests
    {
        private Cart cart;

        // Tests
        [SetUp]
        public void Setup()
        {
            cart = new Cart();

        } // Setup

        [TestCase(100, 5, 10, 115)] // params, last param expected result/return
        public void Cart_Total_Expected(double subTotal, double taxAmount, double shippingAmount, double expectedTotal)
        {
         // Assignments
         cart.CartSubTotal = subTotal;
         cart.CartSalesTaxAmount = taxAmount;
         cart.CartShippingAmount = shippingAmount;

            // Actual Total calculated by the Production Class by the lambda expression in the Cart.cs file

            double actualTotal = cart.CartTotal; 

        // AssertTest
        ClassicAssert.AreEqual(expectedTotal, actualTotal); 
        // 115 = 1245
        
        }


    }
}
