﻿public class Contacts
{
    // Event declaration
    public event EventHandler<object> ContactAdded;

    // Method to add a new contact
    public void AddContact(object contact)
    {
        // Add contact logic...

        // Trigger the event when a new contact is added
        OnContactAdded(contact);
    }

    // Method to raise the event
    protected virtual void OnContactAdded(object contact)
    {
        // Check if there are any subscribers to the event
        ContactAdded?.Invoke(this, contact);
    }
}

class Program
{
    static void Main(string[] args)
    {
        // Create an instance of the Contacts class
        Contacts contacts = new Contacts();

        // Subscribe to the ContactAdded event
        contacts.ContactAdded += Contacts_ContactAdded;

        // Add a new contact
        contacts.AddContact(("John", "Doe", 30));

        // Unsubscribe from the event (optional)
        contacts.ContactAdded -= Contacts_ContactAdded;
    }

    // Event handler method
    private static void Contacts_ContactAdded(object sender, object contact)
    {
        // Pattern matching to check if the contact is a tuple
        if (contact is (string firstName, string lastName, int age) contactTuple)
        {
            Console.WriteLine($"New contact added: {contactTuple.firstName} {contactTuple.lastName}, Age: {contactTuple.age}");
        }
        else
        {
            Console.WriteLine("Invalid contact format");
        }
    }
}
